namespace :angular do
    desc "Builds angular project and moves files into the correct places for deployment."
    task build: :environment do
        # Empty the public folder
        FileUtils.rm_rf("public/.", secure: true)

        # Active locales of the project (en is implicit default)
        locales = ['en', 'de', 'es', 'fr', 'it', 'ja']

        # Copy localized files
        locales.each do |locale|

            # Build the project
            Dir.chdir('frontend') do
                `ng build --configuration=production-#{locale}`
            end

            # Copy the dist to public
            FileUtils.mkdir "public/#{locale}"
            FileUtils.copy_entry "frontend/dist/frontend-#{locale}", "public/#{locale}/"

            # Move the index out of public
            FileUtils.mv "public/#{locale}/index.html", "app/views/skirental_web_frontend/reservations/show_#{locale}.html.erb"

            # Change the htmls lang-attribute and the base-metatag
            file_contents = File.read("app/views/skirental_web_frontend/reservations/show_#{locale}.html.erb")
            file_contents = file_contents.gsub(/lang="en"/, "lang=\"#{locale}\"")
            file_contents = file_contents.gsub(/base href="\/"/, "base href=\"/#{locale}/\"")
            File.open("app/views/skirental_web_frontend/reservations/show_#{locale}.html.erb", "w") {|file| file.puts file_contents }
        end
    end
end
